difference() { 
 union(){ 
         tapered_cuboid();
         Box(); 
       }
         counterBore();
}

//A cuboid with a tapered top
//w - width
//l - length
//h - height
//taper - how much to taper the each edge at the top by

module tapered_cuboid(w, l, h, taper) {
	ho = taper;	hw = w - taper;	hl = l - taper;
	polyhedron( points=[
		[ 0,  0, 0],	[ho, ho, h],
		[hw, ho, h],	[ w,  0, 0],
		[ 0,  l, 0],	[ho, hl, h],
		[hw, hl, h],	[ w,  l, 0] 
	], faces = [
		//side face
		[0, 1, 2],	[2, 3, 0],
		[3, 2, 6],	[6, 7, 3],
		[7, 6, 5],	[5, 4, 7],
		[4, 5, 1],	[1, 0, 4],
		//top face
		[1, 5, 2],	[2, 5, 6],
		//bottom face
		[4, 0, 3],	[7, 4, 3],
	] );
}
module Box(){ //Cuboid
      translate ([0,0,2]) tapered_cuboid(158, 58, 5, 6);
      //Lower frame
      translate ([0,0,0]) cube([158, 58, 2]);
      //Upper frame
      translate ([6,6,7]) cube ([70,46,1]);
    }

module counterBore(){
      //Hollow cuboid and lower frame
      translate ([3,3,1.9]) tapered_cuboid(152,52,3,4);
      translate ([3,3,-0.1]) cube([152,52,2.1]);
      //inlet upper frame
      translate ([7.5,7.5,7.3]) cube ([67,43,1]);
      //Stick slot
      translate ([20,14,4]) cube ([3.2,18,5]);
      translate ([47,18,4]) cube ([2.4,22,5]);
      //Switch
      translate ([56,14,4]) cube ([11,30,5]);
      //translate ([55,19,4]) {cube ([13,20,5]);}
 
    } 

